/*
Copyright Catalin-Alexandru AVRAM
distributed under GNU license agreement
for more information on the GNU license visit www.gnu.org

Functions and variables that should be used from the outside:
friendUID - the user id of the person you are conected with, null if not available
friendstimer - variable to acces the timer from outside
changeView (mainViewName,friendsViewName,showFriends)
	mainViewName - the name of the div containing your main area - must be declared prior to calling the function
	friendsViewName - the name of a div which will be used to show your friend - must also be declared before - any children will be lost
	showFriends - true will hide the main area and show the friends div while false will do the opposite
	
The function OnReceiveTalkData(from,data) should be the only one in need of change to suit your program's need
*/

//Global variables

var friendUID=null;
var uniqueID="ctchess"		//set in order not to interfere with other multiplayer programs (no : please)
var friends = null;
var friendscroll=0;
var friendstimer=null;
var friendstimeraux=null;
var friendlabels=new Array(12);
var friendimages=new Array(12);
var friendivs=new Array(12);
googleTalk.onReceiveTalkData = OnReceiveTalkData;

//Main functions

function refreshFriends(){
	friends=googleTalk.friends.toArray();
	if (friendstimeraux==null){
		friendsarea.appendElement('<div name="scroll_bar" width="15" height="190" x="245" y="5"><img x="0" y="0" width="15" height="190" src="images/multiplayer/scroll_bkg.png"/><progressbar name="scrollBall" enabled="true" y="16" min="0" value="0" orientation="vertical" emptyImage="images/multiplayer/scroll.gif" fullImage="images/multiplayer/scroll.gif" thumbImage="images/multiplayer/scroll_ball.png" thumbOverImage="images/multiplayer/scroll_ball_over.png" thumbDownImage="images/multiplayer/scroll_ball_down.png" tooltip="Scroll through your friends list" onmousemove="scrollDrag()" onclick="scrollDrag()"/><button width="13" height="13" x="1" y="1" image="images/multiplayer/scroll_up.png" overImage="images/multiplayer/scroll_up_over.png" downImage="images/multiplayer/scroll_up_down.png" tooltip="Up" onclick="scrollUp()"/><button width="13" height="13" x="1" y="177" image="images/multiplayer/scroll_down.png" overImage="images/multiplayer/scroll_down_over.png" downImage="images/multiplayer/scroll_down_down.png" tooltip="Down" onclick="scrollDown()"/></div>');
		friendsarea.appendElement('<div name="friend_list" width="245" height="200" x="0" y="0"/>');
		friendsarea.appendElement('<label name="no_friends_online" width="240" height="30" x="65" y="100" color="#000000" font="Arial" size="12" bold="true">No Friends Online</label>');
		for (i=0;i<12;i++){
			friendivs[i]=friend_list.appendElement('<div onclick="selectFriend('+i+')" cursor="hand" enabled="true" onmouseover="friendOver()" onmouseout="friendOut()" width="245" height="15" x="0" y="'+i*15+'"/>');
			friendimages[i]=friendivs[i].appendElement('<img src="" x="7" y="0" />');
			friendlabels[i]=friendivs[i].appendElement('<label x="23" y="0" width="222" height="15" color="#000000" font="Arial" size="9" bold="true"></label>');
		}
	}
	if (friends.length>0) for (i=0; i < friends.length; i++) if (!friends[i].has_sidebar){
		friends.splice(i,1);
		i--;
	}
	
	if (friends.length>12){
	    scroll_bar.visible=true;
	    scrollBall.max=friends.length-12;
	    scrollBall.value=scrollBall.max-friendscroll;
	}else scroll_bar.visible=false;
	if (friends.length>0){
		no_friends_online.visible=false;
		friend_list.visible=true;
		if (friends.length>12 && friends.length<friendscroll+12) friendscroll=friends.length-12;
		for (i=0;i<12;i++){
			if (i+friendscroll<friends.length){
				friendimages[i].src="images/multiplayer/"+(friends[i+friendscroll].status==gddFriendStatusOnline?"available":friends[i+friendscroll].status==gddFriendStatusBusy?"busy":"away")+".gif";
				friendlabels[i].innerText=friends[i+friendscroll].name;
				friendivs[i].visible=true;
			}else friendivs[i].visible=false;
		}
	}else{
		no_friends_online.visible=true;
		friend_list.visible=false;
	}
	friendstimeraux=friendsarea;
	friendstimer=setTimeout("refreshFriends()",10000);
}
function changeView(showFriends){
    friendsarea.opacity=255;
	if (showFriends) {refreshFriends();friendUID=null;block_input=true;} else if (friendstimer!=null) clearInterval(friendstimer);
	friendsarea.visible=showFriends;mainarea.opacity=255-205*showFriends;speed=2+2*showFriends;QuitButton.visible=SaveButton.visible=!showFriends;LoadButton.visible=showFriends;LoadGame.visible=showFriends;
	if (timer!=null) clearInterval(timer);
	if (MoveTimer!=null) clearInterval(MoveTimer);
	if (showFriends) DemoMovie();
	savearea.visible=false;
}

//Event functions

function friendOver(){
	event.srcElement.background = "#ccccff";
}
function friendOut(){
	event.srcElement.background = "";
}
function selectFriend(nr){
	var name=friends[friendscroll+nr].name;
	var id=friends[friendscroll+nr].user_id;
	if (confirm("Are you sure you want to invite "+name+" to play with you ?")){
	    your_turn=white=confirm("Do you want to play with the white pieces ?");
		try {
			friendUID = id;
			var aux=options("Slot"+LoadGame.innerText.charAt(5));
			googleTalk.SendTalkData(id, uniqueID+":invite:"+(white?"black":"white")+(LoadGame.innerText=="New Game"?"":":"+aux.length+":"+aux));
		}catch (e){
			friendUID=null;
			alert("Error : \nCould not connect with "+name+" !\nTry again later or choose another friend.");
		}
	}
}
function scrollUp(){
	if (friendscroll>0){
		friendscroll--;
		clearInterval(friendstimer);
		refreshFriends();
		scrollBall.value=scrollBall.max-friendscroll;
	}
}
function scrollDown(){
	if (friendscroll<friends.length-12){
		friendscroll++;
		clearInterval(friendstimer);
		refreshFriends();
		scrollBall.value=scrollBall.max-friendscroll;
	}
}
function scrollDrag(){
    if (event.button!=1){event.returnValue=false;return;}
    friendscroll=scrollBall.max-scrollBall.value;
    clearInterval(friendstimer);
    refreshFriends();
}
function OnReceiveTalkData(friend, data){
    var daux;
	if (data.match(uniqueID+":invite:")){
	    daux=data.split(":");
	    if (daux.length>3 && friendsarea.visible){
	        ddaux="";
	        for (i=4;i<daux.length;i++) ddaux+=daux[i]+":";
	        ddaux=ddaux.substr(0,parseInt(daux[3],10));
	        mainarea.opacity=255;
	        if (timer!=null) clearInterval(timer);
	        if (MoveTimer!=null) clearInterval(MoveTimer);
	        white=(daux[2]=="white"?true:false);
	        friendsarea.visible=savearea.visible=false;
	        SetStartingPosition(ddaux);
	        setTimeout("ConfirmEnemyLoad('"+ddaux+"','"+friend.name+"','"+friend.user_id+"','"+daux[2]+"')",50);
	    }else if(daux.length<=3){
		    if (confirm(friend.name + " wants to play a game of chess with you.\nYou will play with "+daux[2]+" .\nWould you like to play with him now ? (refusing will allow you to add a reason).")){
			    friendUID = friend.user_id;
			    googleTalk.SendTalkData(friendUID,uniqueID+":accept:"+(daux[2]=="white"?"black":"white"));
			    your_turn=white=(daux[2]=="white"?true:false);
			    block_input=!white;
			    UpLabel.tooltip=friend.name;
			    changeView(false);
			    SetStartingPosition("");
		    }else{
		        var answer=utils.prompt("Give "+friend.name+" a reson for refusing...","I am currently busy");
		        if (!answer) {OnReceiveTalkData(friend,data);return;}
		        googleTalk.SendTalkData(friend.user_id,uniqueID+":decline-reason:"+answer);
		    }
		}else{
		    if (confirm(friend.name + " wants to play a saved game of chess with you.\nYou will play with "+daux[2]+" .\nWould you like to play with him now ? (refusing will allow you to add a reason).\nYou can get more information about the game if you click yes,\nbut you won't be able to return to the current game once you do.")){
                friendsarea.visible=true;
                OnReceiveTalkData(friend, data);
		    }else{
		        var answer=utils.prompt("Give "+friend.name+" a reson for refusing...","I am currently busy");
		        if (!answer) {OnReceiveTalkData(friend,data);return;}
		        googleTalk.SendTalkData(friend.user_id,uniqueID+":decline-reason:"+answer);
		    }

		}
	}else if(data.match(uniqueID+":accept:")){
		if (friendUID==friend.user_id){
		    daux=data.split(":");
		    your_turn=white=(daux[2]=="white"?true:false);
			block_input=!white;
			UpLabel.tooltip=friend.name;
			if (daux.length>3){
	            var ddaux="";
	            for (i=4;i<daux.length;i++) ddaux+=daux[i]+":";
	            ddaux=ddaux.substr(0,parseInt(daux[3],10));
	        }else ddaux="";
			changeView(false);
			SetStartingPosition(ddaux);
		}else googleTalk.SendTalkData(friend.user_id,uniqueID+":quit");
	}else if(data.match(uniqueID+":decline-reason:")){
		if (friendUID==friend.user_id){
			var daux=data.split(":");
			alert(friend.name+" doesn't want to play chess now.\nHis reason is : "+daux[2]);
			changeView(true);
		}
	}else if(data==uniqueID+":quit"){
		if (friendUID==friend.user_id){
			if (confirm(friend.name+" has quit the game !\nDo you want to save the current board position ?")) Load_Save("quit"); else changeView(true);
			friendUID=null;
		}
	}else if(data.match(uniqueID+":move:")){
		if (friendUID==friend.user_id){
			daux=data.split(":");
			if (daux[7]=="done") next_move=null; else{
			    dnextaux=daux[7].split(" ");
			    if (parseInt(dnextaux[7],10)==-2) next_move="MovePiece("+parseInt(dnextaux[1],10)+","+parseInt(dnextaux[3],10)+","+(piese_sus++)+",-1,"+dnextaux[9]+");";
			    else if (parseInt(dnextaux[7],10)==-1) next_move="MovePiece("+parseInt(dnextaux[1],10)+","+parseInt(dnextaux[3],10)+","+(parseInt(dnextaux[5],10))+",-2,"+dnextaux[9]+");";
			    else next_move="MovePiece("+parseInt(dnextaux[1],10)+","+parseInt(dnextaux[3],10)+","+(7-parseInt(dnextaux[5],10))+","+(7-parseInt(dnextaux[7],10))+","+dnextaux[9]+");";			    
			}
			MovePiece(parseInt(daux[2],10),parseInt(daux[3],10),7-parseInt(daux[4],10),7-parseInt(daux[5],10),(daux[6]=="0"?false:true));
		}
	}else if(data.match(uniqueID+":message:")){
	    if (friendUID==friend.user_id){
	        daux=data.split(":");
	        ShowMessage(daux[2]);
	        if (daux[2]=="Mate!") ShowMessage("You Won !!!");
	    }
	}
}

//Main program entry point - restrict to multiplayer related operations please